#ifndef __SLIDEOBJECT_H__
#define __SLIDEOBJECT_H__

#include "slideprimitive.h"

class CSLIDEWorld;
class CSLIDEFace;
class CSLIDEPoint;

//////////////////////////////////////////////////////////////////////////////
// CSLIDEObject Class
//

class CSLIDEObjectIter;

class CSLIDEObject : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Friends
//
public:
  friend class CSLIDEObjectIter;

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEObject();
  virtual ~CSLIDEObject();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CHAR *pcID, 
		    CListInt *plistFaceIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:
  virtual CSLIDEPrimitiveIter *AllocateIter();
  virtual VOID FreeIter(CSLIDEPrimitiveIter *pCSLIDEObjectIter);

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 2
// 

//////////////////////////////////////////////////
// Rendering
//
public:
  virtual VOID Render();

protected:

public:

//////////////////////////////////////////////////
// Input Functions
//
public:
  virtual CSLIDEPoint *SelectPoint(FLOAT fX, FLOAT fY);

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteSLIDEMorph(FILE *fpOutputFile);

// 
// END  : ASSIGNMENT 2
/////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual UINT_32 GetFaceCount();

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistFaceIDs;
  CListInt m_listCSLIDEFace;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

//////////////////////////////////////////////////////////////////////////////
// CSLIDEObjectIter Class
//

class CSLIDEObjectIter : public CSLIDEPrimitiveIter
{
//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEObjectIter();
  virtual ~CSLIDEObjectIter();
  virtual VOID Init(CSLIDEObject *pCSLIDEObject);
  virtual VOID Uninit();

//////////////////////////////////////////////////
// Iteration Functions
//
public:
  virtual CSLIDEFace *PeekFirstCSLIDEFace();
  virtual CSLIDEFace *PeekNextCSLIDEFace();

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListIterInt m_iter;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//


#endif // __SLIDEOBJECT_H__
