#ifndef __SLIDEPOINT_H__
#define __SLIDEPOINT_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////
// CSLIDEPoint Class
//

class CSLIDEPoint : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEPoint();
  virtual ~CSLIDEPoint();

  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CHAR *pcID, 
		    const Point &pt);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:

////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 2
// 

//////////////////////////////////////////////////
// Rendering
//
public:
  virtual VOID Render();
  virtual VOID RenderStartPosition();

//////////////////////////////////////////////////
// Input Functions
//
public:
  virtual CSLIDEPoint *SelectPoint(FLOAT fX, FLOAT fY);
  virtual VOID Move(FLOAT fX, FLOAT fY);

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteSLIDEMorph(FILE *fpOutputFile);

// 
// END  : ASSIGNMENT 2
/////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Point &GetPoint();
  inline const Point &GetStartPoint();

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  Point m_pt;
  Point m_ptStart;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Point &CSLIDEPoint::GetPoint()
{
  return m_pt;
}

inline const Point &CSLIDEPoint::GetStartPoint()
{
  return m_ptStart;
}

#endif // __SLIDEPOINT_H__


